// ChessDoc.h : interface of the CChessDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHESSDOC_H__D4149A7D_E5DE_11D5_8630_0080C8E04F49__INCLUDED_)
#define AFX_CHESSDOC_H__D4149A7D_E5DE_11D5_8630_0080C8E04F49__INCLUDED_

#include "DataType.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define MAXRESULT 100
class CChessDoc : public CDocument
{
protected: // create from serialization only
	CChessDoc();
	DECLARE_DYNCREATE(CChessDoc)

// Attributes
public:
	
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChessDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	BOOL m_bFileOpen;
	int Start2GoalW(unsigned char *start, unsigned char *goal, UINT NUM);
	int BFSA3(unsigned char *start,unsigned char * goal);
	int BFSA2(unsigned char *start,unsigned char *goal);
	int BFSA1(unsigned char *start,unsigned char *goal);
	void SortOpen(CPathNode  **pHead);
	int Start2GoalPS(unsigned char *start,unsigned char *goal,UINT N,UINT NUM);
	int Location(unsigned char *goal,unsigned char ch,UINT NUM);
	int BFS(unsigned char* start,unsigned char *goal);
	int FindRule(unsigned char * state,unsigned char ch,int space);
	int SearchDFS();
	BOOL m_bBeginDraw;
	void IniVar(void);
	int m_nGenerate;
	int m_nSplit;
	int m_nType;
	UINT m_nDepth;
	int DFS(unsigned char *start,unsigned char *goal);
	int Test(unsigned char *start,unsigned char* goal,UINT N,UINT NUM);
	int Start2GoalZ(unsigned char *start,unsigned char *goal,UINT NUM);
	int Start2GoalL(unsigned char *start,unsigned char * goal,UINT N,UINT NUM);
	int Start2GoalS(const unsigned char *start,const unsigned  char *goal,UINT N,UINT NUM);

	CResult m_Result[MAXRESULT];
	int m_nResult;
	UINT m_N;
	UINT m_NUM;
	unsigned char m_strStart[16];
	unsigned char m_strEnd[16];
	virtual ~CChessDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CChessDoc)
	afx_msg void OnFileOpen();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHESSDOC_H__D4149A7D_E5DE_11D5_8630_0080C8E04F49__INCLUDED_)
