// ChessView.h : interface of the CChessView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHESSVIEW_H__D4149A7F_E5DE_11D5_8630_0080C8E04F49__INCLUDED_)
#define AFX_CHESSVIEW_H__D4149A7F_E5DE_11D5_8630_0080C8E04F49__INCLUDED_

#include "DataType.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



class CChessDoc;
class CChessView : public CScrollView
{
protected: // create from serialization only
	CChessView();
	DECLARE_DYNCREATE(CChessView)

// Attributes
public:
	CChessDoc* GetDocument();
	int m_nGenerate;
	int m_nSplit;	
	CResult m_Result[100];
	int m_nResult;
	BYTE m_N;
	BYTE m_NUM;
	unsigned char m_strStart[16];
	unsigned char m_strEnd[16];
	int m_nType;
	UINT m_nDepth;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChessView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	
	CRect m_Rect;
//	UINT NUM;
//	UINT N;
	int Start2GoalZ(unsigned char* start,unsigned char* goal,int NUM);
	int Start2GoalL(unsigned char* start,unsigned char* goal,int N,int NUM);
	int Start2GoalS(unsigned char* start,unsigned char* goal,int N,int NUM);
	int DFS(unsigned char* start,unsigned char* goal,CPoint &p0,int width,int v,int h,CDC* pDC);
	void SearchDFS(CPoint &p0,int width,int v,int h,CDC* pDC);
	void ShowResult(CPoint &p0,int gridwidth,int vert,int hori,CDC *pDC);

	virtual ~CChessView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CChessView)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in ChessView.cpp
inline CChessDoc* CChessView::GetDocument()
   { return (CChessDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHESSVIEW_H__D4149A7F_E5DE_11D5_8630_0080C8E04F49__INCLUDED_)
